clear;
clc;
close all;
addpath(genpath('.'));

%% Mab stochastic environment

R = [0.2 0.3 0.7 0.5];
n_arms = length(R);

%Environment

T = 3000;

% UCB1
N = zeros(1, n_arms);
cum_r = zeros(1, n_arms);

fig = figure();
ind = zeros(T,1);
rewards = zeros(T,1);

for tt = 1:T
    % Algortithm choice
    ind(tt) = UCB1(cum_r, N, tt);
    %ind(tt) = TS(cum_r, N, tt);

    %Plot bounds
    fig = plot_UCB1bound(fig, T, tt, cum_r, N, R, ind(tt));
    
    %Reward
    rewards(tt) = stochastic_env(R, ind(tt));
    
    %Update statistics
    N(ind(tt)) = N(ind(tt)) + 1;
    cum_r(ind(tt)) = cum_r(ind(tt)) + rewards(tt);
end

%% Plot Pseudo Regret

%pseudo_regret =
plot_regret(pseudo_regret);

Delta = max(R) - R;
Delta = Delta(Delta > 0);
%UpperBound = 

hold on
plot(1:T, UpperBound, 'g');

legend({'Pseudo regret' 'UCB1 Upper bound'}, 'Location', 'NorthWest');

%% Compute expected pseudo regret
n_rep = 10;

rewards = zeros(T, n_rep);
for rr = 1:n_rep    
    N = zeros(1, n_arms);
    cum_r = zeros(1, n_arms);

    for tt = 1:T
        % Algortithm choice
        ind(tt, rr) = UCB1(cum_r, N, tt);

        %Reward
        rewards(tt, rr) = stochastic_env(R, ind(tt, rr));
        
        %Update statistics
        N(ind(tt, rr)) = N(ind(tt, rr)) + 1;
        cum_r(ind(tt, rr)) = cum_r(ind(tt, rr)) + rewards(tt, rr);
    end
end


%% Plot Expected Pseudo Regret
%pseudo_regret =
plot_regret(pseudo_regret');

hold on
plot(1:T, UpperBound, 'g');
legend({'Pseudo regret' 'UCB1 Upper bound'}, 'Location', 'NorthWest');
